//DO NOT RUN!!!

(define (square x) (* x x))

(define (new-if predicate then-clause else-clause) 
    (cond ((predicate) (then-clause))
          (else (else-clause))))


(define (sqrt-iter guess x)
   (new-if (good-enough? guess x) 
        guess
        (sqrt-iter (improve guess x) x)))

(define (improve guess x) 
    (average guess (/ x guess)))

(define (average x y) 
    (/ (+ y x) 2 ))

(define (good-enough? guess x)
    (< (abs (- (square guess) x)) 0.001 ))

(define (sqrt x) (sqrt-iter 1.0 x))

(square (sqrt 1000))
