(define (smallest-divisor n)

  (define (find-divisor n test-divisor)
    (cond ((> (square test-divisor) n) n)
          ((divides? test-divisor n) test-divisor)
          (else (find-divisor n (+ 1 test-divisor)))))

  (define (square x) (* x x))

  (define (divides? n m) (= 0 (remainder m n)))

  (find-divisor n 2)

  )

(smallest-divisor 199)

(smallest-divisor 1999)

(smallest-divisor 19999)


