(list 'a 'b 'c) ;; (a b c)

(list (list 'george)) ;; ((george))

(cdr '((x1 x2) (y1 y2))) ;; ((y1 y2))

(cadr '((x1 x2) (y1 y2))) ;; (y1 y2)?

(pair? (car '(a short list))) ;;false

(define (memq item x)
  (cond ((null? x) #f)
  ((eq? item (car x)) (cdr x))
  (else (memq item (cdr x)))))

(memq 'red '((red shoes) (blue shoes))) ;; false

(memq 'red '(red shoes blue socks)) ;; (shoes blue socks)
